'use strict';

exports.__esModule = true;

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

var _isElectron = require('is-electron');

var _isElectron2 = _interopRequireDefault(_isElectron);

var _package = require('./package.json');

var _package2 = _interopRequireDefault(_package);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Defaults to 'production'
/* eslint max-len: 0 */
/* eslint no-console: 0 */
process.env.NODE_ENV = process.env.NODE_ENV || 'production';

var increaseVerbosityLevel = function increaseVerbosityLevel(val, total) {
    return total + 1;
};

var defaultHost = (0, _isElectron2.default)() ? '127.0.0.1' : '0.0.0.0';
var defaultPort = (0, _isElectron2.default)() ? 0 : 8000;

_commander2.default.version(_package2.default.version).usage('[options]').option('-p, --port <port>', 'Set listen port (default: ' + defaultPort + ')', defaultPort).option('-H, --host <host>', 'Set listen address or hostname (default: ' + defaultHost + ')', defaultHost).option('-b, --backlog <backlog>', 'Set listen backlog (default: 511)', 511).option('-v, --verbose', 'Increase the verbosity level (-v, -vv, -vvv)', increaseVerbosityLevel, 0).option('-w, --watch-directory <path>', 'Watch a directory for changes').option('--access-token-lifetime <lifetime>', 'Access token lifetime in seconds or a time span string (default: 30d)').option('--allow-remote-access', 'Allow remote access to the server (default: false)');

// Commander assumes that the first two values in argv are 'node' and appname, and then followed by the args.
// This is not the case when running from a packaged Electron server. Here you have the first value appname and then args.
var normalizedArgv = String(process.argv[0]).indexOf(_package2.default.name) >= 0 ? ['node', _package2.default.name].concat(process.argv.slice(1)) : process.argv;
if (normalizedArgv.length > 1) {
    _commander2.default.parse(normalizedArgv);
}

var launchServer = function launchServer() {
    return new _promise2.default(function (resolve, reject) {
        // Change working directory to 'server' before require('./server')
        process.chdir(_path2.default.resolve(__dirname, 'server'));

        require('./server').createServer({
            port: _commander2.default.port,
            host: _commander2.default.host,
            backlog: _commander2.default.backlog,
            verbosity: _commander2.default.verbose,
            watchDirectory: _commander2.default.watchDirectory,
            accessTokenLifetime: _commander2.default.accessTokenLifetime,
            allowRemoteAccess: !!_commander2.default.allowRemoteAccess,
            controller: _commander2.default.controller
        }, function (err, data) {
            if (err) {
                reject(err);
                return;
            }
            resolve(data);
        });
    });
};

exports.default = launchServer;